/*******************************************************************************

    This routine returns an ASCII representation of a integer class code.

    AUTHOR: Song Yom (HSTX) - based on XDB xclass routine (FORTRAN)
    DATE:   11/94

    MODIFICATION HISTORY:
    DATE    PROGRAMMER      DESCRIPTION
    ----    ----------      -----------

*******************************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAXLEN 1024

#ifdef sun
void hdbi2class(i,s)
    int i;
    char *s;
#else
void hdbi2class(int i,char *s)
#endif
{
    int icode;
    char scode[12];
    char ts[MAXLEN];

/*
    Initialize.
*/

    icode = abs(i);
    sprintf(scode,"%d",icode);
    strcpy(s,"unclassified");

/*
    Determine the ASCII representation of the class code.
*/

    if (icode == 9999)
        strcpy(s,"unidentified");
    else if (icode >= 1000 && icode <= 1599)
    {
        if (scode[1] == '0')
            strcpy(s,"X-ray binary");
        else if (scode[1] == '1')
            strcpy(s,"HMXRB");
        else if (scode[1] == '2')
            strcpy(s,"HMXRB supergiant");
        else if (scode[1] == '3')
            strcpy(s,"HMXRB Be star");
        else if (scode[1] == '4')
            strcpy(s,"LMXRB");
        else if (scode[1] == '5')
            strcpy(s,"LMXRB globular cluster");
        if (scode[2] == '1')
            strcat(s," X-ray pulsar");
        else if (scode[2] == '2')
            strcat(s," burster");
        else if (scode[2] == '3')
            strcat(s," black hole");
        else if (scode[2] == '4')
            strcat(s," QPO");
        else if (scode[2] == '5')
            strcat(s," QPO and black hole");
        else if (scode[2] == '6')
            strcat(s," QPO and pulsar");
        else if (scode[2] == '7')
            strcat(s," QPO and bursts");
        else if (scode[2] == '8')
            strcat(s," QPO, pulsar and bursts");
        else if (scode[2] == '9')
            strcat(s," pulsar and bursts");
        if (scode[3] == '1')
            strcat(s," flares");
        else if (scode[3] == '2')
            strcat(s," jets");
        else if (scode[3] == '3')
            strcat(s," eclipsing");
        else if (scode[3] == '4')
            strcat(s," ultra-soft transient");
        else if (scode[3] == '5')
            strcat(s," soft transient");
        else if (scode[3] == '6')
            strcat(s," hard transient");
        else if (scode[3] == '7')
            strcat(s," eclipsing dipper");
        else if (scode[3] == '8')
            strcat(s," eclipsing ADC");
        else if (scode[3] == '9')
            strcat(s," dipper");
    }
    else if (icode >= 1600 && icode <= 1699)
    {
        strcpy(s,"CV");
        if (scode[2] == '1')
            strcat(s," Classical nova");
        else if (scode[2] == '2')
            strcat(s," Recurrent nova");
        else if (scode[2] == '3')
            strcat(s," AM Her (polar)");
        else if (scode[2] == '4')
            strcat(s," intermediate polar");
        else if (scode[2] == '5')
            strcat(s," dwarf nova");
        else if (scode[2] == '6')
            strcat(s," dwarf nova U Gem type");
        else if (scode[2] == '7')
            strcat(s," dwarf nova Z Cam type");
        else if (scode[2] == '8')
            strcat(s," dwarf nova SU UMa type");
        else if (scode[2] == '9')
            strcat(s," nova like");
        if (scode[3] == '1')
            strcat(s," oscillations");
        else if (scode[3] == '2')
            strcat(s," coherent oscillations");
        else if (scode[3] == '3')
            strcat(s," fast");
        else if (scode[3] == '4')
            strcat(s," slow");
        else if (scode[3] == '5')
            strcat(s," eclipsing");
    }
    else if (icode >= 1700 && icode <= 1799)
    {
        strcpy(s,"Gamma ray");
        if (scode[2] == '0')
            strcat(s," source");
        else if (scode[2] == '1')
            strcat(s," bursts");
        else if (scode[2] == '2')
            strcat(s," bursts soft repeater");
        if (scode[3] == '1')
            strcat(s," pulsar");
    }
    else if (icode >= 1800 && icode <= 1899)
        strcpy(s,"Radio Pulsar");
    else if (icode >= 1900 && icode <= 1999)
    {
        if (scode[2] == '0')
            strcpy(s,"RS CVn star");
        else if (scode[2] == '1')
            strcpy(s,"Algol star");
        else if (scode[2] == '2')
            strcpy(s,"Beta Lyr star");
        else if (scode[2] == '3')
            strcpy(s,"W UMa star");
        else if (scode[2] == '4')
            strcpy(s,"Symbiotic star");
        else if (scode[2] == '5')
            strcpy(s,"Zeta Aurigae star");
        else if (scode[2] == '6')
            strcpy(s,"FK Comae star");
        else if (scode[2] == '7')
            strcpy(s,"UV Ceti type");
        else if (scode[2] == '8')
        {
            strcpy(s,"T Tauri star");
            if (scode[3] == '1')
                strcat(s," (Naked)");
            else if (scode[3] == '2')
                strcat(s," (Post)");
        }
        else if (scode[2] == '9')
        {
            if (scode[3] == '0')
                strcpy(s,"Herbig Ae/Be star");
            else
                strcpy(s,"Be star");
        }
    }
    else if (icode >= 2000 && icode <= 2099)
    {
        strcpy(s,"Wolf Rayet star");
        if (scode[2] == '1')
            strcat(s," WN");
        else if (scode[2] == '2')
            strcat(s," WC");
        else if (scode[2] == '3')
            strcat(s," WO");
        if (scode[3] == '1')
            strcat(s,"1");
        else if (scode[3] == '2')
            strcat(s,"2");
        else if (scode[3] == '3')
            strcat(s,"3");
        else if (scode[3] == '4')
            strcat(s,"4");
        else if (scode[3] == '5')
            strcat(s,"5");
        else if (scode[3] == '6')
            strcat(s,"6");
        else if (scode[3] == '7')
            strcat(s,"7");
        else if (scode[3] == '8')
            strcat(s,"8");
        else if (scode[3] == '9')
            strcat(s,"9");
    }
    else if (icode >= 2100 && icode <= 2899)
    {
        strcpy(s,"star");
        if (scode[1] == '1')
            strcat(s," O");
        else if (scode[1] == '2')
            strcat(s," B");
        else if (scode[1] == '3')
            strcat(s," A");
        else if (scode[1] == '4')
            strcat(s," F");
        else if (scode[1] == '5')
            strcat(s," G");
        else if (scode[1] == '6')
            strcat(s," K");
        else if (scode[1] == '7')
            strcat(s," M");
        else if (scode[1] == '8')
            strcat(s," DMe");
        strncat(s,&scode[2],1);
        if (scode[3] == '1')
            strcat(s,"I");
        else if (scode[3] == '2')
            strcat(s,"II");
        else if (scode[3] == '3')
            strcat(s,"III");
        else if (scode[3] == '4')
            strcat(s,"IV");
        else if (scode[3] == '5')
            strcat(s,"V");
    }
    else if (icode >= 2900 && icode <= 2999)
    {
        if (scode[2] == '0')
            strcpy(s,"Star unclassified");
        else if (scode[2] == '1')
            strcpy(s,"Luyten color class a");
        else if (scode[2] == '2')
            strcpy(s,"Luyten color class a-f");
        else if (scode[2] == '3')
            strcpy(s,"Luyten color class f");
        else if (scode[2] == '4')
            strcpy(s,"Luyten color class f-g");
        else if (scode[2] == '5')
            strcpy(s,"Luyten color class g");
        else if (scode[2] == '6')
            strcpy(s,"Luyten color class g-k");
        else if (scode[2] == '7')
            strcpy(s,"Luyten color class k");
        else if (scode[2] == '8')
            strcpy(s,"Luyten color class k-m");
        else if (scode[2] == '9')
            strcpy(s,"Luyten color class m");
    }
    else if (icode >= 3000 && icode <= 3999)
    {
        if (scode[1] == '0')
            strcpy(s,"Extended galactic");
        else if (scode[1] == '1')
            strcpy(s,"SNR Crab like");
        else if (scode[1] == '2')
            strcpy(s,"SNR");
        else if (scode[1] == '3')
            strcpy(s,"Star forming region");
        else if (scode[1] == '4')
            strcpy(s,"Cloud");
        else if (scode[1] == '5')
            strcpy(s,"Nebula");
        else if (scode[1] == '6')
            strcpy(s,"Open star cluster");
        else if (scode[1] == '7')
            strcpy(s,"OB association/HII region");
        else if (scode[1] == '8')
            strcpy(s,"Herbig-Haro object");
        else if (scode[1] == '9')
            strcpy(s,"Diffuse X-ray emission");
        if (scode[2] == '1')
            strcat(s," shell");
        else if (scode[2] == '2')
            strcat(s," filled-center");
        else if (scode[2] == '3')
            strcat(s," composite");
        else if (scode[2] == '4')
        {
            strcpy(ts,"Dark ");
            strcat(ts,s);
            strcpy(s,ts);
        }
        else if (scode[2] == '5')
        {
            strcpy(ts,"Molecular ");
            strcat(ts,s);
            strcpy(s,ts);
        }
        else if (scode[2] == '6')
        {
            strcpy(ts,"Planetary ");
            strcat(ts,s);
            strcpy(s,ts);
        }
        else if (scode[2] == '7')
        {
            strcpy(ts,"Reflection ");
            strcat(ts,s);
            strcpy(s,ts);
        }
        else if (scode[2] == '8')
        {
            strcpy(ts,"Globular Cluster ");
            strcat(ts,s);
            strcpy(s,ts);
        }
        if (scode[3] == '1')
            strcat(s," radio pulsar");
        else if (scode[3] == '2')
            strcat(s," type I");
        else if (scode[3] == '3')
            strcat(s," type II");
    }
    else if (icode >= 4000 && icode <= 4999)
    {
        strcpy(s,"White dwarf");
        if (scode[1] == '1')
            strcat(s," D A");
        else if (scode[1] == '2')
            strcat(s," D B");
        else if (scode[1] == '3')
            strcat(s," D C");
        else if (scode[1] == '4')
            strcat(s," D O");
        else if (scode[1] == '5')
            strcat(s," D Z");
        else if (scode[1] == '6')
            strcat(s," D Q");
        else if (scode[1] == '7')
            strcat(s," D X");
        else if (scode[1] == '8')
            strcat(s," sD");
        if (scode[1] != '9')
        {
            if (scode[2] == '1')
                strcat(s," A");
            else if (scode[2] == '2')
                strcat(s," B");
            else if (scode[2] == '3')
                strcat(s," C");
            else if (scode[2] == '4')
                strcat(s," O");
            else if (scode[2] == '5')
                strcat(s," Z");
            else if (scode[2] == '6')
                strcat(s," Q");
            else if (scode[2] == '7')
                strcat(s," X");
            else if (scode[2] == '8')
                strcat(s," V");
            else if (scode[2] == '9')
                strcat(s," P");
            if (scode[3] == '1')
                strcat(s," PNN");
            else if (scode[3] == '2')
                strcat(s," PNN detached binary");
            else if (scode[3] == '3')
                strcat(s," detached binary");
            else if (scode[3] == '4')
                strcat(s," O");
            else if (scode[3] == '5')
                strcat(s," Z");
            else if (scode[3] == '6')
                strcat(s," Q");
            else if (scode[3] == '7')
                strcat(s," X");
            else if (scode[3] == '8')
                strcat(s," P");
            else if (scode[3] == '9')
                strcat(s," H");
        }
        else
            strcat(s," PG1159-type");
    }
    else if (icode >= 5000 && icode <= 5099)
    {
        strcpy(s,"Cluster of galaxies");
        if (scode[2] == '1')
            strcat(s," Abell class <0");
        else if (scode[2] == '2')
            strcat(s," Abell class 0");
        else if (scode[2] == '3')
            strcat(s," Abell class 1");
        else if (scode[2] == '4')
            strcat(s," Abell class 2");
        else if (scode[2] == '5')
            strcat(s," Abell class >2");
        else if (scode[2] != '0')
            strcat(s," (non-Abell)");
    }
    else if (icode >= 5500 && icode <= 5599)
        strcpy(s,"Background");
    else if (icode >= 6000 && icode <= 6999)
    {
        if (scode[1] == '0')
            strcpy(s,"Non-active galaxy");
        else if (scode[1] == '1')
            strcpy(s,"Dwarf galaxy");
        else if (scode[1] == '2')
            strcpy(s,"Spiral galaxy");
        else if (scode[1] == '3')
            strcpy(s,"Elliptical galaxy");
        else if (scode[1] == '4')
            strcpy(s,"Starburst galaxy");
        else if (scode[1] == '5')
            strcpy(s,"Interacting galaxy");
        else if (scode[1] == '6')
            strcpy(s,"Irregular galaxy");
        else if (scode[1] == '7')
            strcpy(s,"Galaxy");
        else if (scode[1] == '8')
            strcpy(s,"Lenticular galaxy");
        else if (scode[1] == '9')
            strcpy(s,"Normal galaxy");
        if (scode[2] == '1')
            strcat(s," radio loud");
        else if (scode[2] == '2')
            strcat(s," HII region");
        else if (scode[2] == '3')
            strcat(s," multiple nuclei");
        else if (scode[2] == '4')
            strcat(s," barred");
        else if (scode[2] == '5')
            strcat(s," unbarred");
        else if (scode[2] == '6')
            strcat(s," mixed");
        else if (scode[2] == '7')
            strcat(s," nebulous region");
        if (scode[3] == '1')
            strcat(s," flat radio sp");
        else if (scode[3] == '2')
            strcat(s," steep radio sp");
        else if (scode[3] == '3')
            strcat(s," inverted radio sp");
    }
    else if (icode >= 7000 && icode <= 7999)
    {
        if (scode[1] == '0')
            strcpy(s,"AGN unclassified");
        else if (scode[1] == '1')
            strcpy(s,"Seyfert");
        else if (scode[1] == '2')
            strcpy(s,"QSO");
        else if (scode[1] == '3')
            strcpy(s,"BL Lac");
        else if (scode[1] == '4')
            strcpy(s,"Liner");
        else if (scode[1] == '5')
            strcpy(s,"Radio Galaxy");
        else if (scode[1] == '6')
            strcpy(s,"IR galaxy");
        else if (scode[1] == '7')
            strcpy(s,"OVV");
        else
            strcpy(s,"AGN");
        if (scode[2] == '1')
            strcat(s," radio loud");
        else if (scode[2] == '2')
            strcat(s," radio loud/polarised");
        else if (scode[2] == '3')
            strcat(s," radio quiet");
        else if (scode[2] == '4')
            strcat(s," radio loud/invert spect");
        else if (scode[2] == '5')
            strcat(s," radio loud/flat spect");
        else if (scode[2] == '6')
            strcat(s," radio loud/steep spect");
        else if (scode[2] == '7')
            strcat(s," radio polar/invert spect");
        else if (scode[2] == '8')
            strcat(s," radio polar/flat spect");
        else if (scode[2] == '9')
            strcat(s," radio polar/steep spect");
        if (scode[3] == '1')
            strcat(s," flat radio sp");
        else if (scode[3] == '2')
            strcat(s," steep radio sp");
        else if (scode[3] == '3')
            strcat(s," inverted radio sp");
        else if (scode[3] == '4')
            strcat(s," type 1");
        else if (scode[3] == '5')
            strcat(s," type 1.5");
        else if (scode[3] == '6')
            strcat(s," type 2");
    }
    else if (icode >= 8000 && icode <= 8999)
    {
        if (icode == 8224)
            strcpy(s,"unclassified");
        else if (scode[1] == '0')
            strcpy(s,"Solar system object");
        else if (scode[1] == '1')
            strcpy(s,"Planet");
        else if (scode[1] == '2')
            strcpy(s,"The Sun");
        else if (scode[1] == '3')
            strcpy(s,"Asteroid");
        else if (scode[1] == '4')
            strcpy(s,"Comet");
        else if (scode[1] == '5')
            strcpy(s,"Moon");
    }
    else if (icode >= 9000 && icode <= 9998)
    {
        if (scode[1] == '0')
            strcpy(s,"Unusual object");
    }

    return;
}
