/*******************************************************************************

    This routine converts the SHF format time to ASCII format time
    (yy.ddd hh:mm:ss)

    AUTHOR: Song Yom (HSTX) - based on XANADU timka routine (FORTRAN)
    DATE:   11/94

    MODIFICATION HISTORY:
    DATE    PROGRAMMER      DESCRIPTION
    ----    ----------      -----------

*******************************************************************************/

#include <stdio.h>

#ifdef sun
void hdbshf2atim(shf,buffer)
    int shf;
    char *buffer;
#else
void hdbshf2atim(int shf,char *buffer)
#endif
{
    int i;
    int val;
    int yy;
    int dd;
    int hh;
    int mm;
    int ss;
    static int key[] =
    {
        -378691200,-347068800,-315532800,-283996800,-252460800,-220838400,
        -189302400,-157766400,-126230400,-94608000,-63072000,-31536000,0,
        31622400,63158400,94694400,126230400,157852800,189388800,220924800,
        252460800,284083200,315619200,347155200,378691200,410313600,441849600,
        473385600,504921600,536544000,568080000,599616000,631152000
    };
    static int nkey = (sizeof key / sizeof key[0]);

/*
    Find the year offset.
*/

    i = nkey - 1;
    while (shf < key[i] && i)
        --i;

/*
    Calculate year, day, hour, minute, and second.
*/

    yy = 68 + i;
    yy %= 100;
    val = shf - key[i];
    ss = val % 60;
    val /= 60;
    mm = val % 60;
    val /= 60;
    hh = val % 24;
    dd = val / 24 + 1;

/*
    Write the ASCII format time to return buffer.
*/

    sprintf(buffer,"%02d.%03d %02d:%02d:%02d",yy,dd,hh,mm,ss);

    return;
}
